﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Input;
using System.Collections.ObjectModel;

namespace XAMDataChartIssue
{
    public class TestVM : SPVBaseVM
    {
        private DateTime m_XAxisMinimumTime;
        private DateTime m_XAxisMaximumTime;
        private TimeSpan m_XAxisInterval = new TimeSpan(0, 0, 1);

        public TestVM()
        {
            XAxisMinimumTime = new DateTime(0001, 1, 1, 0, 0, 43, 983);   //------> Doesn't work
            //XAxisMinimumTime = DateTime.MinValue;                         //------> Work's even though it's a smaller value than the above
            //XAxisMinimumTime = new DateTime(0001, 1, 1, 1, 0, 43, 983);     //------> Work's. I just added an hour to the first line
            XAxisMaximumTime = DateTime.MaxValue;
        }

        public DateTime XAxisMaximumTime
        {
            get { return m_XAxisMaximumTime; }
            set
            {
                if (value == m_XAxisMaximumTime)
                    return;

                m_XAxisMaximumTime = value;

                OnPropertyChanged("XAxisMaximumTime");
            }
        }

        public DateTime XAxisMinimumTime
        {
            get { return m_XAxisMinimumTime; }
            set
            {
                if (value == m_XAxisMinimumTime)
                    return;

                m_XAxisMinimumTime = value;

                OnPropertyChanged("XAxisMinimumTime");
            }
        }

        public TimeSpan XAxisInterval
        {
            get { return m_XAxisInterval; }
            set
            {
                if (value == m_XAxisInterval)
                    return;

                m_XAxisInterval = value;

                OnPropertyChanged("XAxisInterval");
            }
        }

    }

    public abstract class SPVBaseVM : INotifyPropertyChanged
    {
        private readonly Dictionary<string, PropertyChangedEventArgs> eventArgsCache;
        public event PropertyChangedEventHandler PropertyChanged;

        protected SPVBaseVM()
        {
            eventArgsCache = new Dictionary<string, PropertyChangedEventArgs>();
        }

        protected void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventArgs args;
            if (!eventArgsCache.TryGetValue(propertyName, out args))
            {
                args = new PropertyChangedEventArgs(propertyName);
                eventArgsCache.Add(propertyName, args);
            }

            OnPropertyChanged(args);
        }

        protected void OnPropertyChanged(PropertyChangedEventArgs args)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, args);
        }
    }
}
